scala.util.matching

# Regex

#### class Regex extends Serializable

This class provides methods for creating and using regular expressions. It is based on the regular expressions of the JDK since 1.4.

Its main goal is to extract strings that match a pattern, or the subgroups that make it up. For that reason, it is usually used with for comprehensions and matching (see methods for examples).

A Regex is created from a java.lang.String representation of the regular expression pattern1. That pattern is compiled during construction, so frequently used patterns should be declared outside loops if performance is of concern. Possibly, they might be declared on a companion object, so that they need only to be initialized once.

The canonical way of creating regex patterns is by using the method `r`, provided on java.lang.String through an implicit conversion into WrappedString. Using triple quotes to write these strings avoids having to quote the backslash character (`\`).

Using the constructor directly, on the other hand, makes it possible to declare names for subgroups in the pattern.

For example, both declarations below generate the same regex, but the second one associate names with the subgroups.

     val dateP1 = """(\d\d\d\d)-(\d\d)-(\d\d)""".r
     val dateP2 = new scala.util.matching.Regex("""(\d\d\d\d)-(\d\d)-(\d\d)""", "year", "month", "day")

There are two ways of using a `Regex` to find a pattern: calling methods on Regex, such as `findFirstIn` or `findAllIn`, or using it as an extractor in a pattern match.

Note, however, that when Regex is used as an extractor in a pattern match, it only succeeds if the whole text can be matched. For this reason, one usually calls a method to find the matching substrings, and then use it as an extractor to break match into subgroups.

As an example, the above patterns can be used like this:

     val dateP1(year, month, day) = "2011-07-15"

     // val dateP1(year, month, day) = "Date 2011-07-15" // throws an exception at runtime

     val copyright: String = dateP1 findFirstIn "Date of this document: 2011-07-15" match {
       case Some(dateP1(year, month, day)) => "Copyright "+year
       case None                           => "No copyright"
     }

     val copyright: Option[String] = for {
       dateP1(year, month, day) <- dateP1 findFirstIn "Last modified 2011-07-15"
     } yield year

     def getYears(text: String): Iterator[String] = for (dateP1(year, _, _) <- dateP1 findAllIn text) yield year
     def getFirstDay(text: String): Option[String] = for (m <- dateP2 findFirstMatchIn text) yield m group "day"

Regex does not provide a method that returns a Boolean. One can use java.lang.String `matches` method, or, if `Regex` is preferred, either ignore the return value or test the `Option` for emptyness. For example:

     def hasDate(text: String): Boolean = (dateP1 findFirstIn text).nonEmpty
     def printLinesWithDates(lines: Traversable[String]) {
       lines foreach { line =>
         dateP1 findFirstIn line foreach { _ => println(line) }
       }
     }

There are also methods that can be used to replace the patterns on a text. The substitutions can be simple replacements, or more complex functions. For example:

     val months = Map( 1 -> "Jan", 2 -> "Feb", 3 -> "Mar",
                       4 -> "Apr", 5 -> "May", 6 -> "Jun",
                       7 -> "Jul", 8 -> "Aug", 9 -> "Sep",
                       10 -> "Oct", 11 -> "Nov", 12 -> "Dec")

     import scala.util.matching.Regex.Match
     def reformatDate(text: String) = dateP2 replaceAllIn ( text, (m: Match) =>
       "%s %s, %s" format (months(m group "month" toInt), m group "day", m group "year")
     )

You can use special pattern syntax constructs like `(?idmsux-idmsux)`¹ to switch various regex compilation options like `CASE_INSENSITIVE` or `UNICODE_CASE`.

Annotations
  @SerialVersionUID( uid = 2094783597747625537L )
Source
  Regex.scala
Version

  1.1, 29/01/2008

Note

  ¹ A detailed description is available in java.util.regex.Pattern.

See also

  java.util.regex.Pattern

Linear Supertypes
Serializable, Serializable, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Regex
2. Serializable
3. Serializable
4. AnyRef
5. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Regex(regex: String, groupNames: String*)

   regex

     A string representing a regular expression

   groupNames

     A mapping from names to indices in capture groups

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

8. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

9. #### def equals(arg0: Any): Boolean

   The equality method for reference types.

   The equality method for reference types. See equals in Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

10. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

11. #### def findAllIn(source: CharSequence): MatchIterator

    Return all matches of this regexp in given character sequence as a scala.util.mathcing.Regex.MatchIterator, which is a special Iterator that returns the matched strings, but can also be converted into a normal iterator that returns objects of type Match that can be queried for data such as the text that precedes the match, subgroups, etc.

    Return all matches of this regexp in given character sequence as a scala.util.mathcing.Regex.MatchIterator, which is a special Iterator that returns the matched strings, but can also be converted into a normal iterator that returns objects of type Match that can be queried for data such as the text that precedes the match, subgroups, etc.

    source

      The text to match against.

    returns

      A scala.util.matching.Reegex.MatchIterator of all matches.

    Example:

    1.     for (words <- """\w+""".r findAllIn "A simple example.") yield words

12. #### def findFirstIn(source: CharSequence): Option[String]

    Return optionally first matching string of this regexp in given character sequence, or None if it does not exist.

    Return optionally first matching string of this regexp in given character sequence, or None if it does not exist.

    source

      The text to match against.

    returns

      An Option of the first matching string in the text.

    Example:

    1.     """\w+""".r findFirstIn "A simple example." foreach println // prints "A"

13. #### def findFirstMatchIn(source: CharSequence): Option[Match]

    Return optionally first match of this regexp in given character sequence, or None if it does not exist.

    Return optionally first match of this regexp in given character sequence, or None if it does not exist.

    The main difference between this method and `findFirstIn` is that the (optional) return type for this is Match, through which more data can be obtained about the match, such as the strings that precede and follow it, or subgroups.

    source

      The text to match against.

    returns

      A Option of Match of the first matching string in the text.

    Example:

    1.     ("""[a-z]""".r findFirstMatchIn "A simple example.") map (_.start) // returns Some(2), the index of the first match in the text

14. #### def findPrefixMatchOf(source: CharSequence): Option[Match]

    Return optionally match of this regexp at the beginning of the given character sequence, or None if regexp matches no prefix of the character sequence.

    Return optionally match of this regexp at the beginning of the given character sequence, or None if regexp matches no prefix of the character sequence.

    The main difference from this method to `findFirstMatchIn` is that this method will not return any matches that do not begin at the start of the text being matched against.

    source

      The text to match against.

    returns

      A Option of the Match of the matched string.

    Example:

    1.     """\w+""".r findPrefixMatchOf "A simple example." map (_.after) // returns Some(" simple example.")

15. #### def findPrefixOf(source: CharSequence): Option[String]

    Return optionally match of this regexp at the beginning of the given character sequence, or None if regexp matches no prefix of the character sequence.

    Return optionally match of this regexp at the beginning of the given character sequence, or None if regexp matches no prefix of the character sequence.

    The main difference from this method to `findFirstIn` is that this method will not return any matches that do not begin at the start of the text being matched against.

    source

      The text to match against.

    returns

      A Option of the matched prefix.

    Example:

    1.     """[a-z]""".r findPrefixOf "A simple example." // returns None, since the text does not begin with a lowercase letter

16. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

17. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### val pattern: Pattern

    The compiled pattern

23. #### def replaceAllIn(target: CharSequence, replacer: (Match) ⇒ String): String

    Replaces all matches using a replacer function.

    Replaces all matches using a replacer function. The replacer function takes a Match so that extra information can be obtained from the match. For example:

        import scala.util.matching.Regex
        val datePattern = new Regex("""(\d\d\d\d)-(\d\d)-(\d\d)""", "year", "month", "day")
        val text = "From 2011-07-15 to 2011-07-17"
        val repl = datePattern replaceAllIn (text, m => m.group("month")+"/"+m.group("day"))

    In the replacement String, a dollar sign (`$`) followed by a number will be interpreted as a reference to a group in the matched pattern, with numbers 1 through 9 corresponding to the first nine groups, and 0 standing for the whole match. Any other character is an error. The backslash (`\`) character will be interpreted as an escape character, and can be used to escape the dollar sign. One can use Regex's `quoteReplacement` to automatically escape these characters.

    target

      The string to match.

    replacer

      The function which maps a match to another string.

    returns

      The target string after replacements.

24. #### def replaceAllIn(target: CharSequence, replacement: String): String

    Replaces all matches by a string.

    Replaces all matches by a string.

    In the replacement String, a dollar sign (`$`) followed by a number will be interpreted as a reference to a group in the matched pattern, with numbers 1 through 9 corresponding to the first nine groups, and 0 standing for the whole match. Any other character is an error. The backslash (`\`) character will be interpreted as an escape character, and can be used to escape the dollar sign. One can use Regex's `quoteReplacement` to automatically escape these characters.

    target

      The string to match

    replacement

      The string that will replace each match

    returns

      The resulting string

    Example:

    1.     """\d+""".r replaceAllIn ("July 15", "<NUMBER>") // returns "July <NUMBER>"

25. #### def replaceFirstIn(target: CharSequence, replacement: String): String

    Replaces the first match by a string.

    Replaces the first match by a string.

    In the replacement String, a dollar sign (`$`) followed by a number will be interpreted as a reference to a group in the matched pattern, with numbers 1 through 9 corresponding to the first nine groups, and 0 standing for the whole match. Any other character is an error. The backslash (`\`) character will be interpreted as an escape character, and can be used to escape the dollar sign. One can use Regex's `quoteReplacement` to automatically escape these characters.

    target

      The string to match

    replacement

      The string that will replace the match

    returns

      The resulting string

26. #### def replaceSomeIn(target: CharSequence, replacer: (Match) ⇒ Option[String]): String

    Replaces some of the matches using a replacer function that returns an Option.

    Replaces some of the matches using a replacer function that returns an Option. The replacer function takes a Match so that extra information can be btained from the match. For example:

        import scala.util.matching.Regex._

        val map = Map("x" -> "a var", "y" -> """some $ and \ signs""")
        val text = "A text with variables %x, %y and %z."
        val varPattern = """%(\w+)""".r
        val mapper = (m: Match) => map get (m group 1) map (quoteReplacement(_))
        val repl = varPattern replaceSomeIn (text, mapper)

    In the replacement String, a dollar sign (`$`) followed by a number will be interpreted as a reference to a group in the matched pattern, with numbers 1 through 9 corresponding to the first nine groups, and 0 standing for the whole match. Any other character is an error. The backslash (`\`) character will be interpreted as an escape character, and can be used to escape the dollar sign. One can use Regex's `quoteReplacement` to automatically escape these characters.

    target

      The string to match.

    replacer

      The function which optionally maps a match to another string.

    returns

      The target string after replacements.

27. #### def split(toSplit: CharSequence): Array[String]

    Splits the provided character sequence around matches of this regexp.

    Splits the provided character sequence around matches of this regexp.

    toSplit

      The character sequence to split

    returns

      The array of strings computed by splitting the input around matches of this regexp

28. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

29. #### def toString(): String

    The string defining the regular expression

    The string defining the regular expression

    returns

      a String representation of the object.

    Definition Classes
      Regex → AnyRef → Any

30. #### def unapplySeq(target: Any): Option[List[String]]

    Tries to match target (whole match) and returns the matching subgroups.

    Tries to match target (whole match) and returns the matching subgroups. if the pattern has no subgroups, then it returns an empty list on a successful match.

    Note, however, that if some subgroup has not been matched, a `null` will be returned for that subgroup.

    For example:

         val p1 = "ab*c".r
         val p2 = "a(b*)c".r

         val p1Matches = "abbbc" match {
           case p1() => true
           case _    => false
         }

         val numberOfB = "abbbc" match {
           case p2(b) => Some(b.length)
           case _     => None
         }

    target

      The string to match

    returns

      The matches

31. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

32. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

33. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any